#include<bits/stdc++.h>
using namespace std;
int main()
{
    ios_base::sync_with_stdio(false);
    long long n;
    cin>>n;
    long long del[n/2+1], brP=0, ch=0, brD=0;
    for(int u=1; u<=n/2; u++)
    {
        if(n%u==0)
        {
            del[ch]=u;
            ch++;
        }
    }
    del[ch]=12;
    ch++;

    for(int j=0; j<ch/2; j++)
    {
        for(int i=j+1; i<=n/del[j]; i++)
        {
            if((n/del[j])%i==0 && (n/del[j])/i>j)
            {
                brD++;
            }
        }
        if(brD%2==0)
        {
            brP+=brD/2;
        }
        else
        {
            brP+=brD/2+1;
            brD=0;
        }
        cout<<brP<<"\n";

        return 0;
    }
